require "nixio.fs"
require "cellulard/u_string"
--json = require "json"

uqmi = {}

qmidevices = {}

function uqmi.get_devices()
	return qmidevices
end


function uqmi.init()
	local devices, count = nixio.fs.glob("/dev/cdc-*")
	local device
	local i = 1
	for device in devices do
		print("QMI Device: ".. device)
		qmidevices[i]=device
		i = i + 1
	end
	--[[
	if nixiofs.stat("/tmp/xnet_modems.json", 'type') == 'reg' then
		local devices = json.decode(nixio.fs.readfile("/tmp/xnet_modems.json"))
		local c = 1
		for i,device in pairs(devices)
		do
			if entry["cdc"] ~= nil then
				print("QMI Device: ".. device)
				qmidevices[c]= "/dev/"..device
		end

	end
	]]
end

function uqmi.get_imei(device)
	local f, imei

	f = io.popen ("uqmi --single -d " ..device.. " --get-imei")
	imei = f:read('*all')

	f:close()

	return trim(imei)
end


function uqmi.get_signal_info(device)
	local f, json_signal_info, net_type, rssi
	f = io.popen ("uqmi --single -d " .. device .. " --get-signal-info")
	json_signal_info = json.decode(f:read('*all'))	
	
	net_type = json_signal_info["type"]
	if json_signal_info["rssi"] ~= nil then
		rssi = json_signal_info["rssi"]
	end
	if json_signal_info["signal"] ~= nil then
		rssi = json_signal_info["signal"]
	end
	
	
	f:close()

	return net_type, rssi
end


function uqmi.get_serving_system(device)
	local f, json_serving_system, registration, plmn_mcc, plmn_mnc, roaming

	f = io.popen ("uqmi --single -d " .. device .. " --get-serving-system")
	json_serving_system = json.decode(f:read('*all'))
	
	registration = json_serving_system["registration"]
	plmn_mcc = json_serving_system["plmn_mcc"]
	plmn_mnc = json_serving_system["plmn_mnc"]
	roaming = json_serving_system["roaming"]
	plmn_description = json_serving_system["plmn_description"]

	f:close()

	return registration, plmn_mcc, plmn_mnc, roaming, plmn_description
end


function uqmi.get_data_status(device)
	local f, data_connectivity

	f = io.popen ("uqmi --single -d " .. device .. " --get-data-status")
	data_connectivity = f:read('*all')
	f:close()

	return trim(data_connectivity)
end

return uqmi

